#include "stdafx.h"

// winding number = 2
int hasAlmostW2 (cplx z, double delta)
{
  double x;
  double y;
  double xLeft;
  double xRight;
  double yCoord;

  x = real(z);
  y = fabs(imag(z));
  xLeft = (double)(2.0 * sqrt(2.0) - 2.0);
  xRight = 2.0;
  if (x < xLeft - delta || xRight + delta < x)
    return(0);
  yCoord = (double)(sqrt(fabs( -x * x - 4.0 * sqrt(5.0 - 2.0 * x) + 8.0 )));
  if (yCoord + delta <= y)
    return(0);
  return(1);
}

// Gosper's method
// http://www.math.utexas.edu/pipermail/maxima/2006/000126.html
cplx Gosper_2F1 (cplx a, cplx b, cplx c, cplx z)
{
  int k;
	//cplx K;
  int kMax;
  cplx d_k;
  cplx e_k;
  cplx f_k;
  cplx d_k1;
  cplx e_k1;
  cplx f_k1, t;
  cplx xi;
  cplx lambda;
  cplx mu;
  cplx result;

  if (abs(z) <= 0.5)
		return(series_2F1(a, b, c, z));

  kMax = 2000;
  xi = z / (z - 1.0);
  mu = c - a - b;
  d_k = 0.0;
  e_k = 1.0;
  f_k = 0.0;
  for (k = 0; k <= kMax; k++)
  {
		//K = (cplx) k;
    lambda = ((cplx) k + a) * ((cplx) k + b) / ((cplx) k + 1.0) / (2.0 * (cplx) k + c) / (2.0 * (cplx) k + c + 1.0);
    d_k1 = (lambda * z * (xi * d_k * (mu + (cplx) k) + e_k));
    e_k1 = (lambda * z * (-a * b * xi * d_k + ((cplx) k + c) * e_k));
		t    =  d_k * (-(cplx) k / (-1.0 + z) - (b * a - (mu + (cplx) k) * (cplx) k) / (2.0 * (cplx) k + c) * xi) + e_k;
    f_k1 = (f_k + t);
    if (areEqual(f_k1, f_k) == 1 && norm(t) <= SQRT_DBL_EPSILON && 3 < k)
      break;
    d_k = (d_k1);
    e_k = (e_k1);
    f_k = (f_k1);
  }
  result = f_k;

	if ( (abs(z) < 1.0) &&
			(imag(a) == 0.0) && (imag(b) == 0.0) && (imag(c) == 0.0) && (fabs(imag(z)) <= 1e-100) )
		result = real(result) + 0.0*theI;
  
	return(result);
}
