// hyp2f1.cpp : Defines the entry point for the DLL application.

#include "stdafx.h"

int _tmain(int argc, _TCHAR* argv[])
{
	return 0;
}

extern "C" __declspec( dllexport ) 
void __stdcall  hyp2f1_mpl(double *inputArray, double *resultArray)
{
	cplx a,b,c,z;
	double x,y;
	cplx result;

	a = cplx(inputArray[0],inputArray[1]);
	b = cplx(inputArray[2],inputArray[3]);
	c = cplx(inputArray[4],inputArray[5]);

	x = inputArray[6]; y = inputArray[7];

	// branch cut
	if ( (1.0 < x) && (fabs(y) <= 1e-306) )
		y = - (1e-306);

	z = x + y*theI;

	result = G_2F1(a,b,c,z);

	resultArray[0]= real(result);
	resultArray[1]= imag(result);

	// clean up branch cut
	if ( fabs(resultArray[1]) <= 1e-300)
		resultArray[1] = 0.0;
	
	if ( (x < 1.0) && (fabs(y) <= 1e-300) 
		&&(imag(a) == 0.0) && (imag(b) == 0.0) && (imag(c) == 0.0) )
		resultArray[1] = 0.0;
}

// interface for Excel
extern "C" __declspec( dllexport ) 
cplx_structure __stdcall Gamma_xl(
	double reZ, 
	double imZ)
{
	cplx z;
	cplx result;
	cplx_structure Result;

	z = reZ + imZ * theI;

	result = GAMMA(z);

	Result.re= real(result);
	Result.im= imag(result);

	return (Result);
}

extern "C" __declspec( dllexport ) 
cplx_structure __stdcall hyp2f1_xl(     
	double reA, double imA, 
  double reB, double imB,
  double reC, double imC,
  double reZ, double imZ)
{
	cplx a,b,c,z;
	cplx result;
	cplx_structure Result;

	a = cplx(reA,imA);
	b = cplx(reB,imB);
	c = cplx(reC,imC);
	z = cplx(reZ,imZ);

	if ( fabs(imZ) <= 1e-306)
		z = cplx(reZ, - (1e-306));

	result = G_2F1(a,b,c,z);

  Result.re= real(result);
	Result.im= imag(result);

	if ( fabs(Result.im) <= 1e-300)
		Result.im = 0.0;

	return (Result);
}
