#include <cmath>
#include <complex>
using namespace std;

#define DBL_EPSILON				2.2204460492503131e-16		// float.h, 2^(-52)
#define SQRT_DBL_EPSILON  1.4901161193847656e-08		// 2^(-26)
//#define STEPSIZE					0.152587890625000000e-4		// 2^(-16)
#define STEPSIZE					0.26041666666666667e-2		// 1/384 
//#define EPS								0.39062500000000000e-2		// 2^(-8)
#define PI								3.14159265358979324

typedef complex<double> cplx;

#define theI							(cplx(0.0, 1.0))
#define ZERO							(cplx(0.0, 0.0))

// interface, structure for Excel
typedef struct
{
	double re,im;
}
cplx_structure;

// numTools

int areClose (const double x1, const double x2, const double epsilon);
int areEqual (cplx a, cplx b);

int roundToInteger (double x);
int isNumericalInteger (cplx z);
int isNumericalNaturalNumber (cplx z);
int isOdd (int m);

cplx invSINN (cplx mu);


// gamma
cplx GAMMA(cplx z);
cplx invGAMMA (cplx a);

// seriesCase
cplx series_2F1 (cplx A, cplx B, cplx C, cplx Z);
cplx polynom_2F1 (cplx A, cplx B, cplx C, cplx Z,
  int deg);

// gosper
int hasAlmostW2 (cplx z, double delta);
cplx Gosper_2F1 (cplx a, cplx b, cplx c, cplx z);

// linTransforms
cplx AS_15_3_4_polynom (cplx a, cplx b, cplx c, cplx z);
cplx AS_15_3_6_Leb (cplx a, cplx b, cplx c, cplx z);
cplx AS_15_3_7_Leb (cplx a, cplx b, cplx c, cplx z);
cplx AS_15_3_9_Leb (cplx a, cplx b, cplx c, cplx z);

// exceptionals
cplx exceptional_15_3_6 (cplx a, cplx b, cplx c, cplx z);
cplx exceptional_15_3_7 (cplx a, cplx b, cplx c, cplx z);
cplx exceptional_15_3_9 (cplx a, cplx b, cplx c, cplx z);

// theMain
cplx G_2F1 (cplx a, cplx b, cplx c, cplx z);
