#include "stdafx.h"

// abs(z) <= 1, actually only used for abs(z) < 1/2
cplx series_2F1 (cplx a, cplx b, cplx c, cplx z)
{
  int n;
  int nMax;
  cplx r;
  cplx s;
  cplx sNew;
  cplx t;

  nMax = 2000;

  if (areEqual(a, 0.0) == 1 || areEqual(b, 0.0) == 1)
    return(1.0);
  if (areEqual(z, 0.0) == 1)
    return(1.0);

  n = 0;
  s = 1.0;
  t = 1.0;
  while (n < nMax)
  {
    n = n + 1;
    r = (a * b / c / (cplx) n * z);
    t = (t * r);
    sNew = (t + s);
    if ( areEqual(sNew,s) == 1 && 3 < n && norm(t) < SQRT_DBL_EPSILON)
      break;
    else
      s = (sNew);
    
    a = (a + 1.0);
    b = (b + 1.0);
    c = (c + 1.0);
  }

	// clean up
	if ( (imag(a) == 0.0) && (imag(b) == 0.0) && (imag(c) == 0.0) && (fabs(imag(z)) <= 1e-100) )
		s = real(s) + 0.0*theI;

  return(s);
}

cplx polynom_2F1 (cplx a, cplx b, cplx c, cplx z,
  int deg)
{
  int n;
  int nMax;
  cplx r;
  cplx s;
  cplx t;

  if (2000 < deg)
    nMax = 2000;
  else
    nMax = deg;

  if (nMax == 0)
    return(1.0);
  if (areEqual(a, 0.0) == 1 || areEqual(b, 0.0) == 1)
    return(1.0);
  if (areEqual(z, 0.0) == 1)
    return(1.0);
  
	if (nMax == 1)
    return(1.0 + a * b / c * z);

	n = 0;
  s = 1.0;
  t = 1.0;
  while (n < nMax)
  {
    n = n + 1;
    r = a * b / c / (cplx) n * z;
		if (areEqual(r, 0.0) == 1)
      break;

    t = t * r;
    s = t + s;
    a = a + 1.0;
    b = b + 1.0;
    c = c + 1.0;
  }

	// clean up for the real case
	if ( (imag(a) == 0.0) && (imag(b) == 0.0) && (imag(c) == 0.0) && (fabs(imag(z)) <= 1e-100) )
		s = real(s) + 0.0*theI;

  return(s);
}