#include "stdafx.h"

cplx G_2F1 (cplx a, cplx b, cplx c, cplx z)
{
	cplx result;
  double delta;
  cplx w;
	cplx M;

  delta = (double)((sqrt(2.0) - 1.0) / 8.0); // ~ 0.05

	if (areEqual(z, 0.0) == 1)
    return(1.0);

	if (isNumericalNaturalNumber(-c) == 1)
    return(0.1e308);
  
	if (isNumericalNaturalNumber(-a) == 1 || isNumericalNaturalNumber(-b) == 1)
    return(polynom_2F1(a, b, c, z, 1111));
	
	if (isNumericalNaturalNumber(a - c) == 1 || isNumericalNaturalNumber(b - c) == 1)
    return(AS_15_3_4_polynom(a, b, c, z)); // Euler's relation gives a polynom for that


	if (areEqual(z, 1.0) == 1)	// branching point: care only for the classical case
  {
    if (real(c - a - b) <= DBL_EPSILON)
      return(0.1e308);
    return(GAMMA(c) * GAMMA(c - a - b) * invGAMMA(c - a) * invGAMMA(c - b));
  }


	if (2.0 - delta <= abs(z))
    return(AS_15_3_7_Leb(a, b, c, z));	//w = 1 / z;

	if (hasAlmostW2(z, delta) == 1 && 0.5 < real(z) && abs(z) <= 1.5)
    return(AS_15_3_6_Leb(a, b, c, z));	//w = 1 - z;

	if (hasAlmostW2(z, delta) == 1)
    return(AS_15_3_9_Leb(a, b, c, z));	//w = 1 - 1 / z;
  
	result = Gosper_2F1(a, b, c, z);
  return(result);
}
